 # Copyright (c) 1998 by Toshio Endo. All rights reserved.
 #
 # THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
 # OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
 #
 # Permission is hereby granted to use or copy this program
 # for any purpose,  provided the above notices are retained on all copies.
 # Permission to modify the code and to distribute modified code is granted,
 # provided the above notices are retained, and a notice that the code was
 # modified is included with the above copyright notice.

 # Endo, Feb 17, 1999
	
 #	This file requires MIPS-II architecture.
 #	This file uses LL, SC, SYNC.
 #	Use -mips2 option.

#include <sys/asm.h>	
		
	.text

 #
 #	void PSM_sync_write(long *p, long n)
 #
	.globl	PSM_sync_write
	.ent	PSM_sync_write
PSM_sync_write:
 #	1st argument is $4
 #	2nd argument is $5
	LONG_S	$5,0($4)
	sync
	j	$31
	.end	PSM_sync_write


 #
 #	long PSM_compare_and_swap(long *p, long oldn, long newn)
 #
	.globl	PSM_compare_and_swap
	.ent	PSM_compare_and_swap
PSM_compare_and_swap:
 #	1st argument is $4
 #	2nd argument is $5
 #	3rd argument is $6
 #	Return value is $2
	LONG_LL	$2,($4)
	.set	noreorder
	.set	nomacro
	bne	$2,$5,PSM_CAS1
	move	$2,$0
	.set	macro
	.set	reorder
	LONG_SC	$6,($4)
	sltu	$2,$0,$6
PSM_CAS1:
	j	$31
	.end	PSM_compare_and_swap
