/ Copyright (c) 1998 by Toshio Endo. All rights reserved.
/
/ THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
/ OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
/
/ Permission is hereby granted to use or copy this program
/ for any purpose,  provided the above notices are retained on all copies.
/ Permission to modify the code and to distribute modified code is granted,
/ provided the above notices are retained, and a notice that the code was
/ modified is included with the above copyright notice.

/ Endo, Aug 14, 1998

/	This file requires 486 architecture.
/	This file uses XCHG, lock+CMPXCHG.
/	Use -m486 option.

.text

/
/	void PSM_sync_write(int *p, int n)
/
	.globl PSM_sync_write
	.type	 PSM_sync_write,@function
PSM_sync_write:
/	1st argument is 8(%ebp)
/	2nd argument is 12(%ebp)

	pushl %ebp
	movl %esp,%ebp
	pushl %ebx
	pushl %ecx
	movl 8(%ebp),%ebx
	movl 12(%ebp),%eax
	xchg (%ebx),%eax
	popl %ecx
	popl %ebx
	movl %ebp,%esp
	popl %ebp
	ret
	
/
/	int PSM_compare_and_swap(int *p, int oldn, int newn)
/
	.globl PSM_compare_and_swap
	.type	 PSM_compare_and_swap,@function
PSM_compare_and_swap:
/	1st argument is 8(%ebp)
/	2nd argument is 12(%ebp)
/	3rd argument is 16(%ebp)
/	Return value is %eax

	pushl %ebp
	movl %esp,%ebp
	pushl %ebx
	pushl %ecx
	movl 8(%ebp),%ebx
	movl 12(%ebp),%eax
	movl 16(%ebp),%ecx
	lock
	cmpxchg %ecx,(%ebx)
	movl $0,%eax
	sete %al
	popl %ecx
	popl %ebx
	movl %ebp,%esp
	popl %ebp
	ret
