! Copyright (c) 1998 by Toshio Endo. All rights reserved.
!
! THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
! OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
!
! Permission is hereby granted to use or copy this program
! for any purpose,  provided the above notices are retained on all copies.
! Permission to modify the code and to distribute modified code is granted,
! provided the above notices are retained, and a notice that the code was
! modified is included with the above copyright notice.

! Endo, Aug 14, 1998
	
!	This file requires SPARC-V8plus architecture.
!	This file uses CAS, MEMBAR.
!	Use -Wa,-xarch=v8plus (or -Wa,-xarch=v8plusa) option.

.section	".text"

!
!	void PSM_sync_write(int *p, int n)
!
!	.align 4
	.global PSM_sync_write
	.type	 PSM_sync_write,#function
PSM_sync_write:
!	1st argument is %o0
!	2nd argument is %o1
	
	membar #LoadStore | #StoreStore
	st %o1,[%o0]
	membar #StoreLoad | #StoreStore
	retl
	nop

!
!	int PSM_compare_and_swap(int *p, int oldn, int newn)
!
!	.align 4
	.global PSM_compare_and_swap
	.type	 PSM_compare_and_swap,#function
PSM_compare_and_swap:
!	1st argument is %o0
!	2nd argument is %o1
!	3rd argument is %o2
!	Return value is %o0

	cas [%o0],%o1,%o2
	xor %o1,%o2,%o1
	subcc %g0,%o1,%g0
	subx %g0,-1,%o0
	retl
	nop
